﻿Imports System.Data
Imports Infragistics.Web.UI.GridControls
Public Class WebForm1
    Inherits System.Web.UI.Page
    Protected WithEvents WebHierarchicalDataGrid1 As Infragistics.Web.UI.GridControls.WebHierarchicalDataGrid

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ConfigureDataSource()
    End Sub
    Protected Overrides Sub OnInit(e As EventArgs)
        MyBase.OnInit(e)
        AddHandler Me.WebHierarchicalDataGrid1.RowIslandsPopulating, AddressOf WebHierarchicalDataGrid1_RowIslandsPopulating
        AddHandler Me.WebHierarchicalDataGrid1.InitializeRow, AddressOf WebHierarchicalDataGrid1_InitializeRow

        'If Session("DataSet") Is Nothing Then
        '    'Dim repository = New Repository()
        '    Session("DataSet") = getActorList()
        'End If

        Me.WebHierarchicalDataGrid1.DataSource = Session("DataSet")
    End Sub
    Private Sub ConfigureDataSource()
        If Not IsPostBack Then
            Me.WebHierarchicalDataGrid1.DataSource = GetEmployeeData()
            Me.WebHierarchicalDataGrid1.DataBind()
        End If
    End Sub
    Private Sub WebHierarchicalDataGrid1_InitializeRow(sender As Object, e As RowEventArgs)
        'If e.Row.Index Mod 2 = 0 Then
        '    For i As Integer = 1 To e.Row.Items.Count - 1 Step 2
        '        e.Row.Items(i).CssClass = "chessboard"
        '    Next
        'Else
        '    For i As Integer = 0 To e.Row.Items.Count - 1 Step 2
        '        e.Row.Items(i).CssClass = "chessboard"
        '    Next
        'End If
    End Sub


    'Comment - In fuction GetEmployeeData()- It is loading on page lode- I am getting data from database Oracle stored procedure.As for your understing i took column name added. 
    Private Function GetEmployeeData() As DataTable
        Dim Employee As DataTable = New DataTable("Employee")

        Dim workCol As DataColumn = Employee.Columns.Add( _
            "E_ID", Type.GetType("System.Int32"))
        workCol.AllowDBNull = False
        workCol.Unique = True
        Employee.Columns.Add("E_TYPE", Type.GetType("System.String"))
        Employee.Columns.Add("E_TRD_IND", Type.GetType("System.String"))
        Employee.Columns.Add("US_Employee", Type.GetType("System.String"))
        Return Employee

    End Function
    
    Private Function GetAccountData(ByVal E_ID As String, ByVal E_TRD_IND As String, ByVal E_TYPE As String, ByVal US_Employee As String) As DataTable
        Dim Account As DataTable = New DataTable("Account")
        'Take this data on run time on demand- Get data for account from E_ID which is selected from "Employee" table '
        ' For Example- Employee data is populated on page load- now I am selecting 5 row - which is means clicking on (+) sign. 
        ' 5th row ID is E_ID=01234 
        ' Selected Row -And taking all cell (ID="01234",E_TYPE="IT",E_TRD_IND="Yes",US_Employee="NO") data into variables, which we had selected that means 5th row. And passing to stored procedure and returning datatable

        Return Account

    End Function
    Private Function GetRelationshipData(ByVal ACCOUNT_ID As String, ByVal TYPE_Acct As String, ByVal ACCT_DESC As String, ByVal PTY_ID As String) As DataTable
        Dim Relationship As DataTable = New DataTable("Relationship")
        'Take relationship data from account id which is selected'
        'Take this data on run time on demand'
        Return Relationship

    End Function
    Private Function GetSystemData(ByVal RELNS_ID As String, ByVal RELNTYPE As String, ByVal STATUS As String, ByVal BOOKINGENTITY As String) As DataTable
        Dim System As DataTable = New DataTable("System")
        'Take System data from Relationship id which is selected'
        'Take this data on run time on demand'
        Return System

    End Function
    Sub WebHierarchicalDataGrid1_RowIslandsPopulating(sender As Object, e As ContainerRowCancelEventArgs)
        e.Cancel = True

        Dim dataSet = TryCast(Session("DataSet"), DataSet)

        Dim childTable As DataTable
        'Query comment- How can select row data?
        Select Case e.Row.Level
            Case 0 'Employee row is selected which is 5th Row
                'I am not sure about syntex- But I want selected row for band 0- represnt Employee Table '
                Dim rec As ContainerGridRecord = DirectCast(Me.WebHierarchicalDataGrid1.GridView.Behaviors.Selection.SelectedRows(0), ContainerGridRecord)
                Dim EmployeeID As String = rec.DataKey("E_ID")
                Dim Emp_E_TRD_IND As String = rec.DataKey("E_TRD_IND")
                Dim Emp_E_TYPE As String = rec.DataKey("E_TYPE")
                Dim Emp_US_Employee As String = rec.DataKey("US_Employee")

                'Assume that we got 5 rows relationship row  from E_ID'
                childTable = GetAccountData(EmployeeID, Emp_E_TRD_IND, Emp_E_TYPE, Emp_US_Employee)

                'Query comment- How can i bind more row in parent table after clicking on child, without postback of page ?
                'Custome logic for Employee Datatable'
                '***************Very Importent point********************** please implement it
                ' For Example if I have 10 row in parent table(Employee) and on 5th row selection below condition set true-
                ' There is 5 more row I need to add in parent table(Employee) and bind it without refreshing page and page count from 1 to 2- And Row will be from 10 to 15 rows
                ' If (Some Condition here )=True  then

                ' Need to extra rows in partent Table (Employee) bind it 
                ' End If
            Case 1
                'Account row is selected which is 2th Row
                'I am not sure about syntex- But I want selected row for band 1- represnt Account row selection Table '
                Dim rec As ContainerGridRecord = DirectCast(Me.WebHierarchicalDataGrid1.GridView.Behaviors.Selection.SelectedRows(1), ContainerGridRecord)
                Dim ACCOUNTID As String = rec.DataKey("ACCOUNT_ID")
                Dim TYPEAcct As String = rec.DataKey("TYPE_Acct")
                Dim ACCTDESC As String = rec.DataKey("ACCT_DESC")
                Dim PTYID As String = rec.DataKey("PTY_ID")

                'Assume that we got 5 rows relationship row from ACCOUNT_ID'
                childTable = GetRelationshipData(ACCOUNTID, TYPEAcct, ACCTDESC, PTYID)
            Case 2
                'relationship row is selected which is 3th Row
                'I am not sure about syntex- But I want selected row for band 2- represnt Account row selection Table '
                Dim rec As ContainerGridRecord = DirectCast(Me.WebHierarchicalDataGrid1.GridView.Behaviors.Selection.SelectedRows(2), ContainerGridRecord)
                Dim RELNSID As String = rec.DataKey("RELNS_ID")
                Dim RELNTYPE As String = rec.DataKey("RELNTYPE")
                Dim STATUS As String = rec.DataKey("STATUS")
                Dim BOOKINGENTITY As String = rec.DataKey("BOOKINGENTITY")

                'Assume that we got 5 rows relationship row from ACCOUNT_ID'
                childTable = GetSystemData(RELNSID, RELNTYPE, STATUS, BOOKINGENTITY)
        End Select

        Dim childGrid As New ContainerGrid()

        e.Row.RowIslands.Add(childGrid)
        childGrid.DataSource = childTable
        childGrid.DataBind()
    End Sub
  
End Class

